(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)

(* strangely the two following packages do not protect their symbols *)
Begin["Miscellaneous`SIUnits`"];
Protect[Evaluate[ToExpression[Names["`*"]]]];
End[];

Begin["Miscellaneous`Units`"];
Protect[Evaluate[ToExpression[Names["`*"]]]];
End[];

(* Unit handling package *)
BeginPackage[
    "Lautrup`Units`",{"Miscellaneous`SIUnits`","Miscellaneous`Units`"}];

(* secure reload *)
Unprotect[Evaluate[ToExpression[Names["`*"]]]];
ClearAttributes[{NToCGS,NToMKS,NToSI,NToUnit,ToCGS,ToMKS,ToSI,ToUnit,Unit,
      UnitQ},ReadProtected]; 

(* Usage of unit functions *)

UnitQ::usage="UnitQ[s] is true if a symbol is a unit";
Unit::usage="Unit[q] is the unit of a quantity q";
ToSI::usage="ToSI[q] converts a quantity q to fundamental SI units";
ToMKS::usage="ToMKS[q] converts a quantity q to MKS units";
ToCGS::usage="ToCGS[q] converts a quantity q to CGS units";
ToUnit::usage="ToUnit[u][q] converts a quantity q to unit u";
NToSI::usage="NToSI[q] is the value of a quantity q in SI units";
NToMKS::usage="NToMKS[q] is the value of a quantity q in MKS units";
NToCGS::usage="NToCGS[q] is the value of a quantity q in CGS units";
NToUnit::usage="NToUnit[q] is the value of a quantity q in units of u";

Kilometer::usage="Kilometer is a thousand meter";
Millimeter::usage="Millimeter is a thousands of a meter";
Micrometer::usage="Micrometer is a millionth of a meter";
Nanometer::usage="Nanometer is a billionth of a meter";
RPM::usage="Rotations per minute";
Millisecond::usage="Millisecond is a thousandth of a second";
Microsecond::usage="Microsecond is a millionth of a second";
Nanosecond::usage="Nanosecond is a billionth of a second";
SiderealDay::usage="SiderealDay is a unit of time";

Begin["`Private`"];

(* create list of all known units *)
special={Second,Newton};
extra={Millimeter,Kilometer,Micrometer,Nanometer,RPM,Millisecond,Microsecond,
      Nanosecond,SiderealDay};
units=ToExpression[
      Join[Names["Miscellaneous`Units`*"],Names["Miscellaneous`SIUnits`*"],
        special,extra]];
exceptions={CGS,Convert,ConvertTemperature,MKS,SI};
units=Select[Union[units],!MemberQ[exceptions,#]&];

(* Define logical function UnitQ to be true for any recognized unit name *)
Clear[UnitQ];
Map[(Evaluate[UnitQ[#]]=True) &,units];
UnitQ[x_ y_]:=UnitQ[x]&&UnitQ[y]
UnitQ[Power[x_,_]]:=UnitQ[x]
UnitQ[_]=False;

(* Isolate unit from expression *)		
Unit[x_?UnitQ]:=x
Unit[x_?NumericQ]:=1
Unit[x_ y_]:=Unit[x]Unit[y]

(* General conversion function *)
$ToIntermediate={Millimeter\[Rule]Milli Meter,Kilometer\[Rule]Kilo Meter,
      Micrometer\[Rule]Micro Meter,Nanometer\[Rule]Nano Meter,
      RPM\[Rule]2\[Pi]/Minute,Millisecond\[Rule]Milli Second,
      Microsecond\[Rule]Micro Second,Nanosecond\[Rule]Nano Second,
      SiderealDay\[Rule]Day*SiderealSecond/Second};
ToSI[q_]:= Simplify[
    PowerExpand[
      SI[q//.$ToIntermediate]//.Miscellaneous`Units`Private`$ToFundamental]]
ToMKS[q_]:=ToSI[q]
ToCGS[q_]:=PowerExpand[CGS[ToSI[q]]]
ToUnit[u_?UnitQ][q_]:=ToSI[q/u]u 

(* Numeric conversion functions *)
NToSI[q_]:=With[{r=ToSI[q]},N[r]/Unit[r]]
NToMKS[q_]:=NToSI[q]
NToCGS[q_]:=With[{r=ToCGS[q]},N[r]/Unit[r]]
NToUnit[u_][q_]:=NToSI[q/u]
End[];

(* protect all *)
Protect[Evaluate[ToExpression[Names["`*"]]]];
SetAttributes[{NToCGS,NToMKS,NToSI,NToUnit,ToCGS,ToMKS,ToSI,ToUnit,Unit,
      UnitQ},ReadProtected]; 
 EndPackage[];

























































